// $Id: logging.h,v 1.2 2003/11/06 04:54:08 ensc Exp $    --*- c -*--

// Copyright (C) 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de>
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; version 2 of the License.
//  
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//  
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


#ifndef H_VSERVER_DJINNIE_SRC_LOGGING_H
#define H_VSERVER_DJINNIE_SRC_LOGGING_H

#define VSERVER_DJINNI_MAKE_STRING_XX(X)	#X
#define VSERVER_DJINNI_MAKE_STRING_X(X)		VSERVER_DJINNI_MAKE_STRING_XX(X)
#define VSERVER_DJINNI_GETLINE			VSERVER_DJINNI_MAKE_STRING_X(__LINE__)

#define RETURN_WITH_LOG(ACTION,RETVAL)					\
  do {									\
    Logging_timestamp(2);						\
    WRITE_STR(2, ACTION);						\
    WRITE_MSG(2, ": failed in ");					\
    WRITE_STR(2, __FUNCTION__);						\
    WRITE_MSG(2, " (" __FILE__ ":" VSERVER_DJINNI_GETLINE ")\n");	\
    return RETVAL;							\
  } while (0)

void	Logging_newProcess(char const *name);
void	Logging_timestamp(int fd);

#endif	//  H_VSERVER_DJINNIE_SRC_LOGGING_H
