// $Id: djinni.h,v 1.2 2004/01/09 01:01:55 ensc Exp $    --*- c++ -*--

// Copyright (C) 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de>
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; version 2 of the License.
//  
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//  
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


#ifndef H_UTIL_VSERVER_SRC_DJINNI_H
#define H_UTIL_VSERVER_SRC_DJINNI_H

#include <sys/types.h>

#ifndef DJINNI_CMD_SOCKET
#  define DJINNI_CMD_SOCKET		PKGSOCKDIR "/cmd"
#endif

#ifndef DJINNI_HEARTBEAT_SOCKET
#  define DJINNI_HEARTBEAT_SOCKET	PKGSOCKDIR "/lamp"
#endif

#ifndef DJINNI_CFG_DIR
#  define DJINNI_CFG_DIR		PKGCFGDIR
#endif

#ifndef DJINNI_STATE_DIR
#  define DJINNI_STATE_DIR		PKGSTATEDIR
#endif

#ifndef DJINNID_PID_FILE
#  define DJINNID_PIDFILE		VARRUNDIR "/djinnid.pid"
#endif

#ifndef DJINNI_RUB_PID_FILE
#  define DJINNI_RUB_PIDFILE		VARRUNDIR "/djinni-rub.pid"
#endif

xid_t	getContextOfPid(pid_t pid);
void	getContextOfPid_detach();

#endif	//  H_UTIL_VSERVER_SRC_DJINNI_H
